#!/usr/bin/env Rscript

usePackage <- function(p)
{
  if (!is.element(p, installed.packages()[,1]))
    install.packages(p, dep = TRUE, repos ='http://cran.us.r-project.org')
  require(p, character.only = TRUE)
}
usePackage('SeuratObject')

args <- commandArgs(trailingOnly = TRUE)

data <- readRDS(args[1])
umap_coord <- as.data.frame(data@reductions$umap@cell.embeddings)
metadata <- as.data.frame(data@active.ident)
metadata$Seq <- rownames(metadata)
metadata$Cluster <- data@meta.data$seurat_clusters
metadata$UMAP1 <- umap_coord$UMAP_1
metadata$UMAP2 <- umap_coord$UMAP_2
colnames(metadata) <- c('Cell_Type','Seq_ID', 'Cluster_ID','UMAP1','UMAP2')
counts <- as.data.frame(t(as.data.frame(data[["RNA"]]@counts)))
write.csv(metadata,'metadata.csv')
write.csv(counts,'counts.csv')
